% sos_decomposition1.m

% 2011/01/25   H. Ichihara

clear all;

% polynomial
sdpvar x1 x2;
p = 2*x1^4+3*x1^2*x2^2+2*x1*x2^3+4*x2^4;

% monomial vector and PSD matrix
z = [x1^2 x1*x2 x2^2]';
Q = sdpvar(length(z));

% sos set
Fs = set(coefficients(p-z'*Q*z,[x1,x2])==0);
Fs = Fs+set(Q>=0);

% call solver
options = sdpsettings;
options.solver = 'sedumi';
sol = solvesdp(Fs)

% EOF